% Analysis of bow-tie simulation results

clear;
addpath('C:\_my_files\Tamar_IST_Weizmann\Matlab\mtimesx_20110223'); %fast matrix multiplication. 
addpath('C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files'); % where data is stored
addpath('C:\_my_files\Tamar_IST_Weizmann\my_texts\bow-ties\MSB\simulation_code')

%%

% D = 6, L = 4, No noise
% read simulation data till 3,000 generations
L = 4; % # matrices in the model.
D = 6; % matrix dimension
Rank = [1 2 3 6]; 
Nfiles = [3000, 3000, 1500, 707];

dir_path{1} = 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1\6D_rank_1_no_noise_goal';
dir_path{2} = 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1\6D_rank_2_no_noise_goal';
dir_path{3} = 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1\6D_rank_3_no_noise_goal';
dir_path{4} = 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1\6D_rank_6_no_noise_goal';
for rr = 1:length(Rank) % rank
    cd(dir_path{rr});
    N = Nfiles(rr); % # files
    data_6D_4L(rr).Layer_width_del_F = zeros(N,L+1);
    data_6D_4L(rr).rank = Rank(rr);
    index = 0;
    for kk = 1:N, 
        fname = ['Mult_Mat_10k_gen_r',num2str(Rank(rr)),'_6D_goal_4L_',num2str(kk),'.mat']; 
        if exist(fname, 'file')
            load(fname);  
            if abs(mean_fitness(end)) < 0.01 % analyze only converged runs
                index = index + 1;
                [F, del_F_over_F] = node_effect_on_fitness(A, G, 1);
                data_6D_4L(rr).Layer_width_del_F(index,:) = sum(del_F_over_F./repmat(sum(del_F_over_F,2),[1 D]) > 0.001, 2);
            else
                message = ['run did not converge in file ',fname];
                disp(message);
            end; % if mean_fitness(end) < 0.01
        else  % if exist(fname, 'file')
                disp(fname); 
        end; % if exist(fname, 'file')
    end; % for kk = 1:length(L), 
    if index < N % trim zeros
        data_6D_4L(rr).Layer_width_del_F = data_6D_4L(rr).Layer_width_del_F(1:index,:);
    end; % if index < N % trim zeros
     median(data_6D_4L(rr).Layer_width_del_F)
end;

%% fraction of runs that did not reach the most minimal bow-tie: 
% 27/1/2014

cd 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1'
load('data_6D_4L.mat');
 for ii=1:4,
     Bow{ii} = data_6D_4L(ii).Layer_width_del_F(:,3);
     non_converged(ii) =  sum(Bow{ii} ~= data_6D_4L(ii).rank) / length(Bow{ii});
 end;



%% D = 8, L = 6, rank = 4, goals with same rank but different number of zeros 

% Test the dependenceon goal structure (# zeros)
% read simulation data 
L = 6; % # matrices in the model.
D = 8; % matrix dimension
Zero_num = [8 16 32 48]; 
clear Nfiles;
Nfiles{1} = 1:500; % The rest of the files are on Pablo's computer - copy them!
Nfiles{2} = 1:500;
Nfiles{3} = 1:500;
Nfiles{4} = 1:500;
clear fname;
% There is a problem with the 'mean_fitness' variable in the files of the
% first directory. Looks like I saved the same variable in all files.
% Calculate fitness, rather than use this variable.
dir_path{1} = 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1\8D_rank_4_8_zeros_no_noise';
dir_path{2} = 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1\8D_rank_4_16_zeros_no_noise';
dir_path{3} = 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1\8D_rank_4_half_zeros_goal';
dir_path{4} = 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1\8D_rank_4_no_noise_goal';
fname{1} = 'dat_file = [''Mult_Mat_r4_8_zeros_8D_goal_6L_'',num2str(kk),''.mat''];'; 
fname{2} = 'dat_file = [''Mult_Mat_r4_16_zeros_8D_goal_6L_'',num2str(kk),''.mat''];'; 
fname{3} = 'dat_file = [''Mult_Mat_r4_half_zeros_8D_goal_6L_'',num2str(kk),''.mat''];'; 
fname{4} = 'dat_file = [''Mult_Mat_100k_gen_r4_8D_goal_6L_'',num2str(kk),''.mat''];';
for rr = 1:length(Zero_num) % rank
    cd(dir_path{rr});
    N = length(Nfiles{rr}); % # files
    data_8D_6L_var_z(rr).Layer_width_del_F = zeros(N,L+1);
    data_8D_6L_var_z(rr).zeros = Zero_num(rr);
    A_zeros = cell(1,L); % small terms of A are considered zeros.
    index = 0;
    for kk = 1:N, 
        eval(fname{rr});
        if exist(dat_file, 'file')
            load(dat_file);
            Fitness = fitness_mult(A, G, 1, 1, 0, 0); 
            if abs(Fitness) < 0.01 % analyze only converged runs
                index = index + 1;
                [F, del_F_over_F] = node_effect_on_fitness(A, G, 1);
                data_8D_6L_var_z(rr).Layer_width_del_F(index,:) = sum(del_F_over_F./repmat(sum(del_F_over_F,2),[1 D]) > 0.001, 2);
                data_8D_6L_var_z(rr).fname(index) = kk;
            else
                message = ['run did not converge in file ',dat_file];
                disp(message);
            end;
        else
                disp(dat_file); 
        end; % if exist(fname, 'file')
    end; % for kk = 1:length(L), 
    if index < N % trim zeros

        data_8D_6L_var_z(rr).Layer_width_del_F = data_8D_6L_var_z(rr).Layer_width_del_F(1:index,:);
    end; % if index < N % trim zeros
       median(data_8D_6L_var_z(rr).Layer_width_del_F)
end; % for rr

%% fraction of runs that did not reach the most minimal bow-tie: 
% 27/1/2014
% cd 'C:\_my_files\Tamar_IST_Weizmann\modularity\bow-ties\data_files\Multiply_A3_times_A2_times_A1'
% load('data_8D_6L_r4_var_z.mat');
for ii = 1:length(data_8D_6L_var_z)
     Bow{ii} = data_8D_6L_var_z(ii).Layer_width_del_F(:,5);
     non_converged(ii) =  sum(Bow{ii} ~= data_8D_6L_var_z(ii).rank) / length(Bow{ii});
 end;



