(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     12038,        341]
NotebookOptionsPosition[     11665,        324]
NotebookOutlinePosition[     12020,        340]
CellTagsIndexPosition[     11977,        337]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"in", "=", 
   RowBox[{"Tuples", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "4", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"out", "=", 
   RowBox[{"Boole", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"And", "@@", "#"}], ",", 
         RowBox[{"Or", "@@", "#"}]}], "}"}], "]"}], "&"}], "/@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Count", "[", 
             RowBox[{"#", ",", "1"}], "]"}], "\[GreaterEqual]", "1"}], "&"}], 
          "/@", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", 
              RowBox[{"{", 
               RowBox[{"1", ",", "3"}], "}"}], "]"}], "]"}], ",", 
            RowBox[{"#", "[", 
             RowBox[{"[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "4"}], "}"}], "]"}], "]"}]}], "}"}]}], ")"}],
         "&"}], "/@", "in"}], ")"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.601483869863819*^9, 3.601483890425008*^9}, 
   3.6018794370001993`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", " ", 
     RowBox[{"l", " ", "d", " ", 
      RowBox[{"(", 
       RowBox[{"d", "+", "1"}], ")"}]}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.583492704958559*^9, 3.583492711123356*^9}, {
   3.5834928808890057`*^9, 3.5834928824565287`*^9}, {3.5843290773558607`*^9, 
   3.5843290779538193`*^9}, {3.584598425914057*^9, 3.584598426681671*^9}, {
   3.5845985064537497`*^9, 3.584598507221434*^9}, {3.5845995750656233`*^9, 
   3.58459957655259*^9}, 3.5846164042106037`*^9, {3.586531809461203*^9, 
   3.58653180961283*^9}, {3.586573304988796*^9, 3.586573305478684*^9}, {
   3.586616482588462*^9, 3.5866164944727182`*^9}, 3.601872267112274*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"h", "[", 
   RowBox[{"x_", ",", "th_"}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "2"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Tanh", "[", 
      RowBox[{"(", 
       RowBox[{"x", "-", "th"}], ")"}], "]"}], "+", "1"}], ")"}]}]}], "\n", 
 RowBox[{
  RowBox[{"H", "[", 
   RowBox[{"x_", ",", "th_"}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "2"], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Tanh", "[", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"th", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "\[Transpose]"}], ".", 
          RowBox[{"x", "\[Transpose]"}]}], "-", 
         RowBox[{"th", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "]"}], "+", "1"}], ")"}], 
    "\[Transpose]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "x_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", ",", "a"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"A", "=", 
       RowBox[{"Nest", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"#", ",", "d"}], "]"}], "&"}], ",", 
         RowBox[{"x", "[", 
          RowBox[{"[", 
           RowBox[{";;", 
            RowBox[{"l", " ", 
             SuperscriptBox["d", "2"]}]}], "]"}], "]"}], ",", "2"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"x", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{
             RowBox[{"l", " ", 
              SuperscriptBox["d", "2"]}], "+", "1"}], ";;"}], "]"}], "]"}], 
         ",", "d"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Fold", "[", 
           RowBox[{"H", ",", "in", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"A", ",", "a"}], "}"}], "\[Transpose]"}]}], "]"}], "-", 
          "out"}], "]"}], "2"], "]"}]}]}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"evo", "[", "x_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "child", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"child", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"RandomReal", "[", "]"}], "<", ".2"}], ",", 
           RowBox[{
            RowBox[{"RandomReal", "[", 
             RowBox[{"NormalDistribution", "[", 
              RowBox[{"1", ",", ".5"}], "]"}], "]"}], "#"}], ",", "#"}], 
          "]"}], "&"}], ",", "x", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         SuperscriptBox["E", 
          RowBox[{
           RowBox[{"-", "2"}], 
           RowBox[{"f", "/@", "#"}]}]], "\[Rule]", "#"}], "]"}], "&"}], "/@", 
      
      RowBox[{"RandomChoice", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{"x", ",", "child"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", "4"}], "}"}]}], "]"}]}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"Nest", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"#", ",", "d"}], "]"}], "&"}], ",", 
     RowBox[{"par", "[", 
      RowBox[{"[", 
       RowBox[{";;", 
        RowBox[{"l", " ", 
         SuperscriptBox["d", "2"]}]}], "]"}], "]"}], ",", "2"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"r", "=", 
   RowBox[{"Join", "@@", 
    RowBox[{"(", 
     RowBox[{"Transpose", "/@", "A"}], ")"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5836877941887493`*^9, 3.583687802234983*^9}, 
   3.58368787223981*^9, 3.5840097100068293`*^9, 3.5841147385518923`*^9, {
   3.5841149104486837`*^9, 3.584114976822113*^9}, {3.5841542715522423`*^9, 
   3.5841543108064203`*^9}, {3.584154566762178*^9, 3.584154569439932*^9}, {
   3.584599240157157*^9, 3.584599319177259*^9}, {3.584599414565969*^9, 
   3.5845994162924623`*^9}, 3.584599524518828*^9, {3.5845995820915613`*^9, 
   3.584599618738337*^9}, {3.584599726540678*^9, 3.584599726997814*^9}, {
   3.584599808839517*^9, 3.584599841545084*^9}, 3.584600058036072*^9, {
   3.5846001635345573`*^9, 3.584600169124598*^9}, {3.5846003470675917`*^9, 
   3.58460034819693*^9}, {3.584600459745274*^9, 3.584600463918605*^9}, {
   3.585154309467826*^9, 3.5851543160866947`*^9}, {3.5851543651432543`*^9, 
   3.585154374135954*^9}, {3.585154466483754*^9, 3.5851544763767653`*^9}, {
   3.5851545525413322`*^9, 3.5851545542054577`*^9}, {3.585154616762041*^9, 
   3.585154623176655*^9}, {3.601483914690906*^9, 3.601483939816785*^9}, {
   3.601872483684127*^9, 3.601872543020729*^9}, 3.6018777680567417`*^9, 
   3.601879315210497*^9, 3.6018808846609325`*^9, {3.602474150114591*^9, 
   3.6024741529777546`*^9}, {3.6027373837946963`*^9, 3.602737387488908*^9}, {
   3.602904912985818*^9, 3.602904915162943*^9}, {3.610896712100006*^9, 
   3.610896714162127*^9}}],

Cell[BoxData[
 RowBox[{"ParallelTable", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"pop", "=", 
     RowBox[{"RandomReal", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", " ", 
         RowBox[{"l", " ", "d", " ", 
          RowBox[{"(", 
           RowBox[{"d", "+", "1"}], ")"}]}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"pop", "=", 
       RowBox[{"evo", "[", "pop", "]"}]}], ",", 
      RowBox[{"{", 
       SuperscriptBox["10", "4"], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    
    RowBox[{"best", "=", 
     RowBox[{
      RowBox[{"SortBy", "[", 
       RowBox[{"pop", ",", "f"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"\[CapitalDelta]f", "=", 
     RowBox[{
      FractionBox[
       RowBox[{"f", "/@", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"par", "/.", 
            RowBox[{"i", "\[Rule]", "0"}]}], "/.", 
           RowBox[{"Thread", "[", 
            RowBox[{"par", "\[Rule]", "best"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "par"}], "}"}]}], "]"}]}], 
       RowBox[{"f", "@", "best"}]], "-", "1"}]}], ";", "\n", "\n", 
    RowBox[{"rule", "=", 
     RowBox[{
      RowBox[{"Alternatives", "@@", 
       RowBox[{
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"par", ",", "\[CapitalDelta]f"}], "}"}], 
            "\[Transpose]"}], "[", 
           RowBox[{"[", 
            RowBox[{";;", 
             RowBox[{"l", " ", 
              SuperscriptBox["d", "2"]}]}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[LessEqual]", 
            SuperscriptBox["10", 
             RowBox[{"-", "4"}]]}], "&"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{";;", ",", "1"}], "]"}], "]"}]}], "\[Rule]", "0"}]}], ";", 
    "\n", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Min", "[", 
        RowBox[{"f", "/@", "pop"}], "]"}], ",", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"r", "/.", "rule"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ".."}], "}"}]}], "]"}]}], "}"}], ">>>", 
     "\"\<NonLinearBowTieSum.txt\>\""}]}], "\[IndentingNewLine]", ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "10000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.601483924909494*^9, {3.601484022801374*^9, 3.6014842025865173`*^9}, {
   3.6014843171684113`*^9, 3.6014843175424423`*^9}, 3.6014844287864523`*^9, {
   3.601877803098525*^9, 3.6018778179629803`*^9}, {3.601877901598823*^9, 
   3.601877946676117*^9}, {3.601878002376606*^9, 3.6018780042305202`*^9}, {
   3.6018782130489902`*^9, 3.601878219506482*^9}, {3.60187825523356*^9, 
   3.6018783122257957`*^9}, {3.601878366775168*^9, 3.6018783742280684`*^9}, 
   3.601878516734593*^9, {3.601878753876548*^9, 3.601878754306625*^9}, {
   3.60187930324612*^9, 3.601879305524926*^9}, 3.601880008475631*^9, {
   3.6018808919973526`*^9, 3.601880893494438*^9}, {3.6018809511497355`*^9, 
   3.6018809575651026`*^9}, {3.601881309330222*^9, 3.601881320314851*^9}, {
   3.601881977613446*^9, 3.6018820097012815`*^9}, {3.602387987767976*^9, 
   3.602387989608779*^9}, {3.6024741312325115`*^9, 3.6024741413570905`*^9}, {
   3.602737416299556*^9, 3.602737440416935*^9}, 3.602737518437398*^9, {
   3.6029049248114944`*^9, 3.602904925626541*^9}}]
},
WindowSize->{1280, 752},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 1277, 40, 46, "Input"],
Cell[1837, 62, 947, 20, 80, "Input"],
Cell[2787, 84, 5204, 143, 293, "Input"],
Cell[7994, 229, 3667, 93, 220, "Input"]
}
]
*)

(* End of internal cache information *)
